/* editgets.c - line input w/editing                                        */
/* this code is released to the public domain                               */
/* written by Jon Burchmore                                                 */
/* modifications & enhancements by Bob Stout                                */

/* This is as close to ANSI compliant C that I could come, but it was made  */
/* on an IBM compatable computer, so I designed it for that platform.       */
/* If you're porting it to another computer type, please note how the IBM   */
/* passes enhanced keys.  First, it sends an ASCIIZ (character 0), then a   */
/* standard character.  Anyway, what the switch() statement does is check   */
/* to see if there WAS a zero sent, and if there wasn't, it just "falls"    */
/* through to the default, which handles normal characters.                 */

/* The conio header file provides the getch() function, which returns a     */
/* single character from the KEYBOARD, not stdin, and waits if it must.     */
/* It is be possible to re-write this function for a computer besides an    */
/* IBM PC.                                                                  */

/* It would be possible to check the variable insert, and if it's on, make  */
/* the cursor large, and if it's off, make the cursor small, but my primary */
/* goal is portability, not fancy add-ons                                   */

/* Pardon the lack of comments.  I'm a coder, not an author.  Besides, if   */
/* you can't understand this, DON'T USE IT! (Words to live by)              */

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#undef min
#define min(x,y) (((x) <= (y)) ? (x) : (y))

#define NUL     0x00
#define ESC     0x1B
#define LEFT    0x4B
#define RIGHT   0x4D
#define HOME    0x47
#define END     0x4F
#define INSERT  0x52
#define DELETE  0x53
#define BACKSPC 0x08
#define ENTER   0x0D
#define CTLEND  0x75
#define CTLHOME 0x77
#define CTLRT   0x74
#define CTLLFT  0x73

/*
**  Password mode - '*' is echoed for all characters, only ESC, ENTER,
**  BACKSPC, and CTLHOME are active.
*/

int password_mode = 0;

/*
**  Aruments: 1) Buffer to receive string
**            2) Size of buffer
**            3) Default string
*/

int jgets(char *s, int maxlen, char *string)
{
      char temp[500];
      int insert = 1, done = 0, pos, len, i, j, c, zeroflag;
      int oldx,oldy,newx,newy,xyflag=0;
      oldx=wherex();  oldy=wherey();

      if (NULL == string)
            string = "";

      if (0 != (pos = len = strlen(string)))
            strncpy(temp, string, min(len, maxlen));

      for (i = 0; i < maxlen; ++i)
      {
//            if (NUL == *string)
//                  putchar(' ');
//            else
              if(NUL!=*string)
                 cprintf("%c", *string++);
      }
//      for (i = 0; i < (maxlen - len); ++i)
//            putchar(BACKSPC);
      if(oldy>=25)  xyflag=1;  else  xyflag=0;
      while (!done)
      {
            newx=wherex();  newy=wherey();
            zeroflag = 0;
            if ((c = getch()) == 0)
            {
                  zeroflag = 1;
                  c = getch();
            }
            if((xyflag)&&(!zeroflag))
            {
                newx=wherex();  newy=wherey();
                if((newx==80)&&(c>=32))
                    oldy--;
            }
            switch (c)
            {
            case ESC :
                  if (len == 0)
                  {
                        s[0]=27;
                        s[1]=0;
                        return 0;
                  }
                  if (pos != len)
                  {
                        for (i = pos; i < len; i++)
                              putch(' ');
                        for (i = len; i >= 0; i--)
                        {
                              newx=wherex();  newy=wherey();
                              if((newx==1)&&(newy>oldy))
                                  {   newy--;  gotoxy(80, newy);  }
                              else
                              {
                                  putch(BACKSPC);
                                  putch(' ');
                                  putch(BACKSPC);
                              }
                              newx=wherex();  newy=wherey();
                        }
                        pos = len = 0;
                        s[0]=27;
                        s[1]=0;
                        return 0;
                  }

            case LEFT :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        if (pos == 0)
                              break;
                        pos--;
                        newx=wherex();  newy=wherey();
                        if((newx==1)&&(newy>oldy))
                            {   newy--;  gotoxy(80,newy);   }
                        else
                            putch(BACKSPC);
                        newx=wherex();  newy=wherey();
                        break;
                  }

            case RIGHT :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        if (pos == len)
                              break;
                        if (pos != maxlen)
                        {
                              putch(temp[pos]);
                              pos++;
                        }
                        break;
                  }

            case HOME :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        while (pos-- > 0)
                              putch(BACKSPC);
                        gotoxy(oldx, oldy);
                        pos = 0;
                        break;
                  }

            case END :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        gotoxy(oldx, oldy);
                        pos=0;
                        while (pos < len)
                              putch(temp[pos++]);
                        break;
                  }

            case INSERT :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        insert = (!(insert));
                        if(insert)
                           _setcursortype(2);
                        else
                           _setcursortype(1);
                        break;
                  }

            case DELETE :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        if (pos == len)
                              break;
                        for (i = pos; i < len; i++)
                              temp[i] = temp[i + 1];
                        len--;
                        newx=wherex();  newy=wherey();
                        for (i = pos; i < len; i++)
                              putch(temp[i]);
                        putch(' ');
                        for (i = len + 1; i > pos; i--)
                              putch(BACKSPC);
                        gotoxy(newx, newy);
                        break;
                  }

            case BACKSPC :
                  if (c == BACKSPC)
                  {
                        if (pos == 0)
                              break;
                        if (pos != len)
                        {
                              for (i = pos - 1; i < len; i++)
                                    temp[i] = temp[i + 1];
                              pos--;
                              len--;
                              newx=wherex();  newy=wherey();
                              if((newx==1)&&(newy>oldy))
                                  {   newy--;   gotoxy(80, newy);  }
                              else
                                  putch(BACKSPC);
                              newx=wherex();  newy=wherey();
                              for (i = pos; i < len; i++)
                                    putch(temp[i]);
                              putch(' ');
                              for (i = len; i >= pos; i--)
                                    putch(BACKSPC);
                              gotoxy(newx, newy);
                        }
                        else
                        {
                              newx=wherex();  newy=wherey();
                              if((newx==1)&&(newy>oldy))
                                  {   newy--;  gotoxy(80, newy);  }
                              else
                                  putch(BACKSPC);
                              newx=wherex();  newy=wherey();
                              putch(' ');
                              putch(BACKSPC);
                              gotoxy(newx, newy);
                              pos = --len;
                        }
                        break;
                  }

            case ENTER :
                  if (c == ENTER)
                  {
                        done = 1;
                        break;
                  }

            case CTLEND :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        newx=wherex();  newy=wherey();
                        for (i = pos; i < len; ++i)
                              putch(' ');
                        for (i = pos; i < len; ++i)
                              putch(BACKSPC);
                        gotoxy(newx, newy);
                        len = pos;
                        break;
                  }

            case CTLHOME :
                  if (zeroflag)
                  {
                        if (pos == 0)
                              break;
                        if (pos != len)
                        {
                              while (0 != pos)
                              {
                                    for (i = pos - 1; i < len; i++)
                                          temp[i] = temp[i + 1];
                                    pos--;
                                    len--;
                                    newx=wherex();  newy=wherey();
                                    if((newx==1)&&(newy>oldy))
                                        {   newy--;  gotoxy(80, newy);  }
                                    else
                                        putch(BACKSPC);
                                    newx=wherex();  newy=wherey();
                                    for (i = pos; i < len; i++)
                                          putch(temp[i]);
                                    putch(' ');
                                    for (i = len; i >= pos; i--)
                                          putch(BACKSPC);
                                    gotoxy(newx, newy);
                              }
                        }
                        else
                        {
                              while (0 != pos)
                              {
                                    newx=wherex();  newy=wherey();
                                    if((newx==1)&&(newy>oldy))
                                        {  newy--;   gotoxy(80, newy);  }
                                    else
                                    {
                                         putch(BACKSPC);
                                         putch(' ');
                                         putch(BACKSPC);
                                    }
                                    newx=wherex();  newy=wherey();
                                    pos = --len;
                              }
                        }
                        break;
                  }

            case CTLRT :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        do
                        {
                              if (pos == len)
                                    break;
                              if (pos != maxlen)
                              {
                                    putch(temp[pos]);
                                    pos++;
                              }
                        } while (isspace(temp[pos]));
                        do
                        {
                              if (pos == len)
                                    break;
                              if (pos != maxlen)
                              {
                                    putch(temp[pos]);
                                    pos++;
                              }
                        } while (!isspace(temp[pos]));
                        break;
                  }

            case CTLLFT :
                  if (zeroflag)
                  {
                        if (password_mode)
                              break;
                        do
                        {
                              if (pos == 0)
                                    break;
                              pos--;
                              newx=wherex();  newy=wherey();
                              if((newx==1)&&(newy>oldy))
                                  {  newy--;  gotoxy(80, newy);  }
                              else
                                  putch(BACKSPC);
                              newx=wherex();  newy=wherey();
                        } while (isspace(temp[pos]));
                        do
                        {
                              if (pos == 0)
                                    break;
                              pos--;
                              newx=wherex();  newy=wherey();
                              if((newx==1)&&(newy>oldy))
                                  {  newy--;  gotoxy(80, newy);  }
                              else
                                  putch(BACKSPC);
                              newx=wherex();  newy=wherey();
                        } while (!isspace(temp[pos]));
                        break;
                  }

            default :
                  if (zeroflag)
                        break;
                  if(c==27)
                  {
                     s[0]=27;
                     s[1]=0;
                     return 1;
                  }
                  if(c<32)
                     break;
                  if (c == 0 || pos == maxlen)
                        break;
                  if ((!(insert)) || pos == len)
                  {
                        temp[pos++] = (char)c;
                        if (pos > len) len++;
                        if (password_mode)
                              putch('*');
                        else  putch(c);
                  }
                  else
                  {
                        if (len == maxlen)
                              break;
                        for (i = len++; i >= pos; i--)
                              temp[i + 1] = temp[i];
                        temp[pos++] = (char)c;
                        if (password_mode)
                              putch('*');
                        else  putch(c);
                        newx=wherex();  newy=wherey();
                        for (i = pos; i < len; i++)
                              putch(temp[i]);
                        for (i = len; i > pos; i--)
                              putch(BACKSPC);
                        gotoxy(newx, newy);
                  }
            }
      }
      temp[len] = '\0';
      strcpy(s, temp);
      return len;
}
//#define TEST

#ifdef TEST

void main(void)
{
      char mystring[200];

      memset(mystring, 0, 200);
      fputs("Enter any string: ", stdout);
      jgets(mystring, 200, "This is a test");
      puts("");
      printf("editgets() returned:\n%s\n", mystring);

      password_mode = 1;
      memset(mystring, 0, 60);
      fputs("Enter any password: ", stdout);
      jgets(mystring, 50, NULL);
      puts("");
      printf("editgets() returned:\n%s\n", mystring);
}

#endif
